import java.io.*;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.*;

////////////////////////////////////
//THIS PROGRAM CALCULATES COVERAGE FROM ASSEMBLIES
public class GetWithinAssemblyCoverages{
  public static void main(String[] args){
      try{
	int minCov=Integer.parseInt(args[0]);
	String specAbbrev[] = {"A","H","G","X","Z","M","K","L","P","S"};

	int readCountsNoDup[][] = new int[10][8];
	int readCountsDup[][] = new int[10][8]; 
	double nReadsNoDupHi[] = new double[10];
	double nReadsNoDupMi[] = new double[10];
	double nReadsDupHi[] = new double[10];
	double nReadsDupMi[] = new double[10];

	double sumNReadsDupMi=0;
	double sumNReadsDupHi=0;

 	//double propDmuxdReads[]= {0.099322702,0.066575187,0.093927711,0.084671112,0.113657234,0.097692262,0.130853074,0.067000789,0.098089493,0.148210436};
	int coverage[][][][] = new int[10][8][512][3000];	//[10 species][8 seq types][locus][site]
      
	for(int species=1; species<=10; species++){
		for(int i=0; i<8; i++){
			for(int locus=1; locus<=512; locus++){
				for(int site=1; site<=3000; site++){
					coverage[species-1][i][locus-1][site-1]=0;
				}
			}
		}

		String readType="";
		int readTypeID=0;

		for(int locus=1; locus<=512; locus++){
			System.out.print("\r"+species+"\t"+(locus-1));
			BufferedReader br = new BufferedReader ( new InputStreamReader(new FileInputStream(   new File("Assemblies/"+species+"/ReducedReadAlignments/L"+locus+specAbbrev[species-1]+".fasta") ) ));			
			String tempS=br.readLine();
			int nSites=0;
			int count[]=new int[1];
			while(tempS!=null){
				//determine from the header the read type
				readType=tempS.split("_")[2];				
				if(		readType.equals("Mi500") && tempS.charAt(tempS.length()-1)!='M'){ readTypeID=0;			//e.g. >seq159_2_Hi900_300_@HWI-ST1035:54:D03ERACXX:4:2205:10660:8105/2					
				}else if(	readType.equals("Mi500") && tempS.charAt(tempS.length()-1)=='M'){ readTypeID=1;
				}else if(	readType.equals("Hi500") && tempS.charAt(tempS.length()-1)!='M'){ readTypeID=2;
				}else if(	readType.equals("Hi500") && tempS.charAt(tempS.length()-1)=='M'){ readTypeID=3;			
				}else if(	readType.equals("Hi700") && tempS.charAt(tempS.length()-1)!='M'){ readTypeID=4;
				}else if(	readType.equals("Hi700") && tempS.charAt(tempS.length()-1)=='M'){ readTypeID=5;
				}else if(	readType.equals("Hi900") && tempS.charAt(tempS.length()-1)!='M'){ readTypeID=6;
				}else if(	readType.equals("Hi900") && tempS.charAt(tempS.length()-1)=='M'){ readTypeID=7;
				}else{readTypeID=8;}
				
				tempS=br.readLine();	//get the sequence
				for(int site=0; site<tempS.length(); site++){
					if(tempS.charAt(site)!='-'){coverage[species-1][readTypeID][locus-1][site]++;}
				}
				tempS=br.readLine();	//get the header
			}
			br.close();

		}
		System.out.println();
		
		//get the nread information
		String filenameNoDup="";
		String filenameDup="";
		for(int i=0; i<8; i++){
			switch(i){
				case 0: filenameNoDup="s_"+species+"_nodup_U1.fastq";		filenameDup="s_"+species+"_U1.fastq";	break;
				case 1: filenameNoDup="s_"+species+"_M_nodup.fastq";		filenameDup="s_"+species+"_M.fastq";		break;
				case 2:	filenameNoDup="s_"+species+"_500_nodup_U1.fastq";	filenameDup="s_"+species+"_500_U1.fastq";	break;
				case 3:	filenameNoDup="s_"+species+"_500_M_nodup.fastq";	filenameDup="s_"+species+"_500_M.fastq";	break;
				case 4:	filenameNoDup="s_"+species+"_700_nodup_U1.fastq";	filenameDup="s_"+species+"_700_U1.fastq";	break;
				case 5:	filenameNoDup="s_"+species+"_700_M_nodup.fastq";	filenameDup="s_"+species+"_700_M.fastq";	break;
				case 6:	filenameNoDup="s_"+species+"_900_nodup_U1.fastq";	filenameDup="s_"+species+"_900_U1.fastq";	break;
				case 7:	filenameNoDup="s_"+species+"_900_M_nodup.fastq";	filenameDup="s_"+species+"_900_M.fastq";	break;
			}
			BufferedReader br = new BufferedReader ( new InputStreamReader(new FileInputStream(   new File("reads/duplicatesRemoved/"+filenameNoDup) ) ));
			String tempS=br.readLine();
			readCountsNoDup[species-1][i]=0;
			while(tempS!=null){
				readCountsNoDup[species-1][i]++;
				if(i<2){ nReadsNoDupMi[species-1]++;
				}else{	nReadsNoDupHi[species-1]++;}
				br.readLine();
				br.readLine();
				br.readLine();
				tempS=br.readLine();
			}
			br.close();

			br = new BufferedReader ( new InputStreamReader(new FileInputStream(   new File("reads/"+filenameDup) ) ));
			tempS=br.readLine();
			readCountsDup[species-1][i]=0;
			while(tempS!=null){
				readCountsDup[species-1][i]++;
				if(i<2){ nReadsDupMi[species-1]++;  sumNReadsDupMi++;
				}else{	nReadsDupHi[species-1]++;   sumNReadsDupHi++;}
				br.readLine();
				br.readLine();
				br.readLine();
				tempS=br.readLine();
			}
			br.close();
		}
	}
		
	System.out.println("Total MiSeq Pairs"+sumNReadsDupMi);
	System.out.println("Total HiSeq Pairs="+sumNReadsDupHi);
	
	//Write read counts...
	BufferedWriter bwDup = new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("reads/nReadSummary_dup.txt") ) ));
	BufferedWriter bwNoDup = new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("reads/nReadSummary_nodup.txt") ) ));
	bwDup.write("Mi500U\tMi500M\tHi500U\tHi500M\tHi700U\tHi700M\tHi900U\tHi900\n");
	bwNoDup.write("Mi500U\tMi500M\tHi500U\tHi500M\tHi700U\tHi700M\tHi900U\tHi900\n");
	for(int species=1; species<=10; species++){
		for(int i=0; i<8; i++){
			bwDup.write(readCountsDup[species-1][i]+"\t");
			bwNoDup.write(readCountsNoDup[species-1][i]+"\t");			
		}
		bwDup.write("\n");
		bwNoDup.write("\n");
	}	
	bwDup.flush();
	bwDup.close();
	bwNoDup.flush();
	bwNoDup.close();
	
	System.out.println("Determining Locus Lengths...");
	for(int species=1; species<=10; species++){	
		//get locus lengths
		int locLens[][][] = new int[8][512][10]; 

		for(int i=0; i<8; i++){
			System.out.print("\r"+species+"\t"+(i+1));
			for(int locus=1; locus<=512; locus++){
				for(int ind=1; ind<=10; ind++){	//1 to 512 individuals may be pooled (log 2 scale)
					locLens[i][locus-1][ind-1]=0;
					for(int site=1; site<=3000; site++){
						if(i<2){
							if(coverage[species-1][i][locus-1][site-1]*(sumNReadsDupMi/readCountsNoDup[species-1][i])/Math.pow(2,ind-1)    >= minCov){ locLens[i][locus-1][ind-1]++;}
						}else{
							if(coverage[species-1][i][locus-1][site-1]*(sumNReadsDupHi/readCountsNoDup[species-1][i])/Math.pow(2,ind-1)    >= minCov){ locLens[i][locus-1][ind-1]++;}						
						}
					}
				}
			}
		}
		System.out.println();

		BufferedWriter bw[] = new BufferedWriter[8];
		bw[0]=new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("Assemblies/"+species+"/LocusLengths_Mi500U_"+species+".txt") ) ));
		bw[1]=new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("Assemblies/"+species+"/LocusLengths_Mi500M_"+species+".txt") ) ));
		bw[2]=new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("Assemblies/"+species+"/LocusLengths_Hi500U_"+species+".txt") ) ));
		bw[3]=new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("Assemblies/"+species+"/LocusLengths_Hi500M_"+species+".txt") ) ));
		bw[4]=new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("Assemblies/"+species+"/LocusLengths_Hi700U_"+species+".txt") ) ));
		bw[5]=new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("Assemblies/"+species+"/LocusLengths_Hi700M_"+species+".txt") ) ));
		bw[6]=new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("Assemblies/"+species+"/LocusLengths_Hi900U_"+species+".txt") ) ));
		bw[7]=new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File("Assemblies/"+species+"/LocusLengths_Hi900M_"+species+".txt") ) ));

		for(int i=0; i<8; i++){
			for(int locus=1; locus<=512; locus++){
				for(int ind=1; ind<=10; ind++){
					bw[i].write(locLens[i][locus-1][ind-1]+"\t");
				}
				bw[i].write("\n");
			}
			bw[i].flush();
			bw[i].close();
		}
			
	}

	
      }catch(IOException ioe){System.out.println("<<!!ERROR main()!!>>");}
  }


}
