import java.io.*;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.*;

////////////////////////////////////
//THIS PROGRAM TAKE RAW PAIRED READS AND REMOVES THE REDUNDANT SEQUENCES (SEQUENCE IN PAIR IS IDENTICAL FOR TWO OR MORE PAIRS IF PCR DUPLICATES OCCURR
//NOT THAT READS WITH SEQUENCING ERROR WILL BE REMOVED...so it's not perfect...


public class ReducePCRDuplicates{
  public static void main(String[] args){
      try{

	
	BufferedReader br1 = new BufferedReader ( new InputStreamReader(new FileInputStream(   new File(args[0]) ) ));
	BufferedReader br2 = new BufferedReader ( new InputStreamReader(new FileInputStream(   new File(args[1]) ) ));

	BufferedWriter bw1;
	BufferedWriter bw2;

	BufferedWriter bw;

	BufferedWriter bwX = new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File(args[2]+"_DupCurve.dat") ) ));
	
	Hashtable uPairs = new Hashtable(20000000);	//HASH TABLE WITH UP TO 20 MILLION UNIQUE READS (MORE CAN BE ACCOMODATED BUT WILL SLOW DOWN PROGRAM)

	UPair upair=null;

	int nReads=0;
	int nReadsReduced=0;

	String tempS1=br1.readLine();
	String tempS2=br2.readLine();
	String seq1="";
	String seq2="";
	//read through once to hash all sequences (concatenate forward and reverse, hash in both directions)
	while(tempS1!=null){
		nReads++;
		
		if(nReads%100000==0){System.out.print("\rHashing pair "+nReads+"\t"+nReadsReduced);}
		seq1=br1.readLine();
		seq2=br2.readLine();
		upair = (UPair)uPairs.get(seq1+seq2);
		if(upair==null){
			nReadsReduced++;
			upair = new UPair();
			upair.rev=new UPair();
			upair.count=1;
			upair.rev.count=0;
			uPairs.put(seq1+seq2,upair);
			uPairs.put(seq2+seq1,upair.rev);
		}else{
			upair.count++;
		}
		bwX.write(uPairs.size()+"\n");

		br1.readLine(); br1.readLine(); tempS1=br1.readLine();	//get +, qc, and next header
		br2.readLine(); br2.readLine(); tempS2=br2.readLine();	//get +, qc, and next header
	}
	bwX.flush();
	bwX.close();
	br1.close();
	br2.close();

	System.out.println();
	System.out.println("Number of reads: "+nReads);
	System.out.println("Number of reads after removing PCR duplicates: "+nReadsReduced);
	System.out.println("PCR duplicate rate: "+nReads/(double)nReadsReduced);

	//read through again this time save the first encountered pair of each type
	br1 = new BufferedReader ( new InputStreamReader(new FileInputStream(   new File(args[0]) ) ));
	br2 = new BufferedReader ( new InputStreamReader(new FileInputStream(   new File(args[1]) ) ));

	bw1 = new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File(args[2]) ) ));
	bw2 = new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File(args[3]) ) ));

	bw = new BufferedWriter ( new OutputStreamWriter(new FileOutputStream(   new File(args[4]) ) ));
		
	tempS1=br1.readLine();
	tempS2=br2.readLine();
	seq1="";
	seq2="";
	nReads=0;
	
	while(tempS1!=null){
		nReads++;
		if(nReads%100000==0){System.out.print("\rChecking pair "+nReads);}
		seq1=br1.readLine();
		seq2=br2.readLine();
		upair = (UPair)uPairs.get(seq1+seq2);	//should have been observed, so can assume that it is in hashtable
		if(upair.count>=0){			//will be -1 if already written
			bw1.write(tempS1+"\n");		bw2.write(tempS2+"\n");		//first header
			bw1.write(seq1+"\n");		bw2.write(seq2+"\n");		//reads
			bw1.write(br1.readLine()+"\n");	bw2.write(br2.readLine()+"\n");	//second header +
			bw1.write(br1.readLine()+"\n");	bw2.write(br2.readLine()+"\n");	//quality scores
			bw1.flush();			bw2.flush();
			
			bw.write(tempS1+"\t"+(upair.count+upair.rev.count)+"\n");
			bw.flush();
			
			upair.count=-1;
			upair.rev.count=-1;
		}else{
			br1.readLine();		br2.readLine();
			br1.readLine();		br2.readLine();
		}
		
		tempS1=br1.readLine();	//get next header
		tempS2=br2.readLine();	//get next header		
	}
	System.out.println();
	br1.close();
	br2.close();
	bw1.flush();
	bw2.flush();
	bw1.close();
	bw2.close();


      }catch(IOException ioe){System.out.println("<<!!ERROR main()!!>>");}
  }


}

class UPair{
	int count=0;
	UPair rev=null;
}
